/** 
 * @file llsecondlifeurls.h
 * @brief Global URLs to pages on our web site
 *
 * $LicenseInfo:firstyear=2004&license=viewergpl$
 * 
 * Copyright (c) 2004-2009, Linden Research, Inc.
 * 
 * Second Life Viewer Source Code
 * The source code in this file ("Source Code") is provided by Linden Lab
 * to you under the terms of the GNU General Public License, version 2.0
 * ("GPL"), unless you have obtained a separate licensing agreement
 * ("Other License"), formally executed by you and Linden Lab.  Terms of
 * the GPL can be found in doc/GPL-license.txt in this distribution, or
 * online at http://secondlifegrid.net/programs/open_source/licensing/gplv2
 * 
 * There are special exceptions to the terms and conditions of the GPL as
 * it is applied to this Source Code. View the full text of the exception
 * in the file doc/FLOSS-exception.txt in this software distribution, or
 * online at
 * http://secondlifegrid.net/programs/open_source/licensing/flossexception
 * 
 * By copying, modifying or distributing this software, you acknowledge
 * that you have read and understood your obligations described above,
 * and agree to abide by those obligations.
 * 
 * ALL LINDEN LAB SOURCE CODE IS PROVIDED "AS IS." LINDEN LAB MAKES NO
 * WARRANTIES, EXPRESS, IMPLIED OR OTHERWISE, REGARDING ITS ACCURACY,
 * COMPLETENESS OR PERFORMANCE.
 * $/LicenseInfo$
 */

#ifndef LL_LLSECONDLIFEURLS_H
#define LL_LLSECONDLIFEURLS_H

// Account registration web page
LL_COMMON_API extern const std::string CREATE_ACCOUNT_URL;

// Manage Account
LL_COMMON_API extern const std::string MANAGE_ACCOUNT;

LL_COMMON_API extern const std::string AUCTION_URL;

LL_COMMON_API extern const std::string EVENTS_URL;

/*
// Tier up to a new land level.
LL_COMMON_API extern const std::string TIER_UP_URL;

// Tier up to a new land level.
LL_COMMON_API extern const std::string LAND_URL;
*/

// How to get DirectX 9
LL_COMMON_API extern const std::string DIRECTX_9_URL;

/*
// Upgrade from basic membership to premium membership
LL_COMMON_API extern const std::string UPGRADE_TO_PREMIUM_URL;


// Out of date VIA chipset
LL_COMMON_API extern const std::string VIA_URL;

// Support URL
LL_COMMON_API extern const std::string SUPPORT_URL;

// Linden Blogs page
LL_COMMON_API extern const std::string BLOGS_URL;
*/

// Currency page
LL_COMMON_API extern const std::string BUY_CURRENCY_URL;

/*
// LSL script wiki
LL_COMMON_API extern const std::string LSL_DOC_URL;

// SL KnowledgeBase page
LL_COMMON_API extern const std::string SL_KB_URL;

// Release Notes Redirect URL for Server and Viewer
LL_COMMON_API extern const std::string RELEASE_NOTES_BASE_URL;
*/
#endif
